#include <stdio.h>
#include <cblas.h>

#define NUM_RUNS 3

#define MATRIX_SIZE 512
static double a[MATRIX_SIZE][MATRIX_SIZE];
static double b[MATRIX_SIZE][MATRIX_SIZE];
static double c[MATRIX_SIZE][MATRIX_SIZE];

long long naive_matrix_multiply_estimated_flops(int quiet) {

  long long muls,divs,adds;

  /* setup */
  muls=MATRIX_SIZE*MATRIX_SIZE;
  divs=MATRIX_SIZE*MATRIX_SIZE;
  adds=MATRIX_SIZE*MATRIX_SIZE;

  /* multiply */
  muls+=MATRIX_SIZE*MATRIX_SIZE*MATRIX_SIZE;
  adds+=MATRIX_SIZE*MATRIX_SIZE*MATRIX_SIZE;

  /* sum */
  adds+=MATRIX_SIZE*MATRIX_SIZE;

  if (!quiet) {
     printf("Estimated flops: adds: %lld muls: %lld divs: %lld\n",
	    adds,muls,divs);
  }
  return adds+muls+divs;
}

void naive_matrix_multiply(int quiet) {

  double s;
  int i,j;//,k;

  for(i=0;i<MATRIX_SIZE;i++) {
    for(j=0;j<MATRIX_SIZE;j++) {
      a[i][j]=(double)i*(double)j;
      b[i][j]=(double)i/(double)(j+5);
      c[i][j]=0.0;
    }
  }

//   void cblas_dgemm(const enum CBLAS_ORDER Order, 
//                    const enum CBLAS_TRANSPOSE TransA,
//const enum CBLAS_TRANSPOSE TransB, const int M, const int N,
///const int K, const double alpha, const double *A,
//const int lda, const double *B, const int ldb,
//

   cblas_dgemm(CblasRowMajor,
	 CblasNoTrans,CblasNoTrans,
	 512,512,512,
	 1.0,(const double *)a,512,
	 (const double *)b,512,
	 1.0,(double *)c,512);

//  for(j=0;j<MATRIX_SIZE;j++) {
//     for(i=0;i<MATRIX_SIZE;i++) {
//        for(k=0;k<MATRIX_SIZE;k++) {
//	   c[i][j]+=a[i][k]*b[k][j];
//	}
//     }
//  }

  s=0.0;
  for(i=0;i<MATRIX_SIZE;i++) {
    for(j=0;j<MATRIX_SIZE;j++) {
      s+=c[i][j];
    }
  }

  if (!quiet) printf("Matrix multiply sum: s=%lf\n",s);

  return;
}

int main(int argc, char **argv) 
{

   naive_matrix_multiply(0);
   
   return 0;
}

